def fix_typo_values(data, columns, mapping):
    for row in data:
        for col in columns:
            val=row.get(col)
            if isinstance(val,str):
                val_cleaned=val.strip().lower()
                if val_cleaned in mapping:
                    row[col]=mapping[val_cleaned]
    return data

def strip_withspace(data, columns, mapping):
    for row in data:
        for col in columns:
            val=row.get(col)
            if isinstance(val,str):
                row[col]=val.strip()
    return data

def to_lowercase(data, columns):
    for row in data:
        for col in columns:
            val = row.get(col)
            if isinstance(val, str):
                row[col] = val.lower()
    return data